# Developers' guide

This is the guideline for who would like to contribute to AmgXWrapper, including
expanding AmgXWrapper, reporting issues or bugs, and seeking help.

## Contribute to AmgXWrapper

AmgXWrapper lives on GitHub, so we follow what most GitHub projects do. In other
words, follow these general steps:

1. Fork AmgXWrapper.
2. Create a new branch with any name you like.
3. Make modification.
4. Test and make sure your modification is not breaking AmgXWrapper.
5. Make a pull request from your new branch to our master branch. Remember to
   specify what changed in your branch and why these changes should be made.
6. Give us time to test and discuss your changes.
7. Merge if everything's all set.

AmgXWrapper is a small piece of code, so we currently don't maintain a separate
development branch. You can make pull requests directly to the `master` branch.

The coding style:

1. Use four spaces for an indent, i.e., no tab (`\t`).
2. Try to make each line not exceed 79 characters (a little bit longer is
   acceptable).
3. Use Doxygen style for API documentation
4. Put comments for API users (in Doxygen style) above the prototypes of
   functions, and put comments for AmgXWrapper developers above and in the
   definitions of functions.

## Report issues and seek support

Please use [GitHub repo](https://github.com/barbagroup/AmgXWrapper)'s issue page
to submit bug reports, issues, or any questions.

If you want to contact us in private, please email pychuang@gwu.edu

